package org.one.stone.soup.cursor;

/*
* Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
	* The TreeCursor class is a light weight container for
	* keeping track of node and branch when traversing a tree.
	* @author Nik Cross
*/

public class TreeCursor {
	public Object node;
	public int branchCursor;
/**
 * The constructor sets the initial branch and node.
 * @param cursor	The current branch
 * @param node		The current node
 */

public TreeCursor(int cursor,Object node) {
	super();

	this.node=node;
	branchCursor=cursor;
}
/**
 * The constructor sets the initial node. The branch is set as 0.
 * @param node		The current node
 */


public TreeCursor(Object node) {
	super();

	this.node=node;
	branchCursor=0;
}
}
