package org.one.stone.soup.mjdb.data.field;

import java.util.*;
/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The TimeStampField class is a wrapper for a timestamp value.
	* @author Nik Cross
*/

public class TimeStampField extends Field {
	public static String DEFAULT_ID = "_TimeStamp";

	private long timeStamp;
public TimeStampField()
{
	timeStamp = System.currentTimeMillis();
}
public TimeStampField(long timeStamp) {

	this.timeStamp = timeStamp;
}
public int compare(Field target) throws CompareException {
	return 0;
}
/**
 * Insert the method's description here.
 * Creation date: (01/05/03 12:28:25)
 * @return org.one.stone.soup.mjdb.data.field.DateField
 */
public DateField getDateField() {
	return null;
}
public DateTimeField getDateTimeField() {

	Date date = new Date(timeStamp);

	int year = date.getYear()+1900;
	int day = date.getDay();
	int month = date.getMonth();

	int hour = date.getHours();
	int min = date.getMinutes();
	int sec = date.getSeconds();

	DateTimeField dtf = new DateTimeField();
	dtf.setDate( new DateField(day,month,year) );
	dtf.setTime( new TimeField(hour,min,sec) );

	return dtf;
}
/**
 *
 * @return java.lang.String
 */
public long getTimeStamp() {
	return timeStamp;
}
public String getValue(String name) {
	return ""+timeStamp;
}
public void setValue(String name, String value, Object source) throws LockException {}
public String toString() {
	return Long.toString(timeStamp);
}
}
