package org.one.stone.soup.mjdb.data.functions;

import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.group.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

public final class Join {
public static final Table join(Table tableA,int linkA,Table tableB,int linkB) throws JoinException{

	ColumnSet columnsA = new ColumnSet(tableA);
	ColumnSet columnsB = new ColumnSet(tableB);

	return join(tableA,columnsA,linkA,tableB,columnsB,linkB);
}
public static final Table join(Table tableA,ColumnSet columnsA,int linkA,Table tableB,ColumnSet columnsB,int linkB) throws JoinException{

  try{
	Table result = new Table(columnsA.getNoOfRows()+columnsB.getNoOfRows());
	Table linkTable;
	Row linkRowA;
	Row linkRowB;
	Row newRow;
	int loopCA;
	int loopCB;

	for(int loopR=0;loopR<tableA.getNoOfRows();loopR++)
	{
		linkRowA=tableA.getRow(loopR);

		//System.out.println("Link:"+linkRowA.getField(linkA));
		linkTable = Search.search(tableB,linkB,linkRowA.getField(linkA));
		//System.out.println("Link done");
		if(linkTable.getNoOfRows()==1)
		{
			newRow = new Row(columnsA.getNoOfRows()+columnsB.getNoOfRows());
			result.addRow(newRow,tableA);

			//System.out.println("Linked to 1");
			linkRowB = linkTable.getRow(0);

			for(loopCA=0;loopCA<columnsA.getNoOfRows();loopCA++)
			{
				//System.out.println( "copy columnA "+((IntField)columnsA.getField(ColumnSet.COLUMN_NUMBER,loopCA)).getData() );
				result.setField(
						loopCA,
						tableA.getField(
							((IntField)columnsA.getField(ColumnSet.COLUMN_NUMBER,loopCA)).getValue(),
							loopR
						),
						null
					);
			}
			//System.out.println("Linked columns A");

			for(loopCB=0;loopCB<columnsB.getNoOfRows();loopCB++)
			{
				//System.out.println( "copy columnB "+((IntField)columnsB.getField(ColumnSet.COLUMN_NUMBER,loopCB)).getData() );

				result.setField(
						loopCA+loopCB,
						linkTable.getField(
							((IntField)columnsB.getField(ColumnSet.COLUMN_NUMBER,loopCB)).getValue(),
							0
						),
						null
					);
			}
			//System.out.println("Linked columns B");

		}
		else
		{
			throw new JoinException("Failed to find "+linkRowA.getField(linkA)+" match in table B");
		}
	}
	return result;
  }
  catch(Exception e)
  {
	  throw new JoinException("Join error "+e);
  }
}
}
