package org.one.stone.soup.xapp.factories;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlPathSearch;

public class XappMenuFactory {

	public static XmlElement getMenuDefinition(String menuName)
	{
		XmlElement xMenu = new XmlElement("menu");
		xMenu.addAttribute("name",menuName);
		return xMenu;
	}

	public static void addMenuItem(XmlElement xMenu,String name,String command)
	{
		
		XmlElement xItem = xMenu.addChild("item");
		xItem.addAttribute("name",name);
		xItem.addAttribute("command",command.replace(' ','-'));
	}
	
	public static void addSubMenuItem(XmlElement xMenu,String submenuName,String name,String command)
	{
		XmlElement subMenu = new XmlPathSearch(xMenu).findElement("menu/menu[@name='"+submenuName+"']");
		if(subMenu==null)
		{
			subMenu = xMenu.addChild("menu");
			subMenu.addAttribute("name",submenuName);
		}
		XmlElement xItem = subMenu.addChild("item");
		xItem.addAttribute("name",name);
		xItem.addAttribute("command",command.replace(' ','-'));
	}

}
