package org.one.stone.soup.xapp.javascript;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import org.one.stone.soup.swing.SourceConsole;
import org.one.stone.soup.xml.XmlElement;

public class JavascriptConsole implements Runnable{

	private SourceConsole console;
	private int row;
	private int column;
	private XmlElement function;
	private ActionListener listener;
	
	public JavascriptConsole(ActionListener listener,XmlElement function,int row,int column)
	{
		this.listener = listener;
		this.function = function;
		this.row = row;
		this.column = column;
		
		StringBuffer source = new StringBuffer();
		for(int loop=0;loop<function.getElementCount();loop++)
		{
			//data[loop]=""+function.getData(loop);
			source.append(function.getData(loop));
		}
		
		console = new SourceConsole(source.toString());
		
		new Thread( this,"Source Console" ).start();
	}
	
	
	public void run()
	{
		String source = console.getSourceOnExit();
		function.setValue(source.trim(),0);
		
		listener.actionPerformed(new ActionEvent(this,1,"updateFunction"));
	}


	public int getColumn() {
		return column;
	}


	public XmlElement getFunction() {
		return function;
	}


	public int getRow() {
		return row;
	}
}
