package org.one.stone.soup.xapp.swing.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.containers.XappFrame;

public class XappSwingFrame implements XappFrame {

	private JFrame frame;
	private JScrollPane pane;
	
	public XappSwingFrame()
	{
		frame = new JFrame();
		pane = new JScrollPane();
		//JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		frame.getContentPane().add(pane);
	}
	
	public void add(XappComponent component) {
		pane.setViewportView((Component)component);
	}
	
	public void add(String name, XappComponent component) {
		pane.setViewportView((Component)component);
	}

	public void refresh() {
		frame.doLayout();
	}

	public void setComponent(XappComponent component) {
		if(((Component)component).getParent()!=null)
		{
			XappRootApplication.displayMessage(component.getName()+" is already visible in "+((Component)component).getParent().getName());
			hide();
			return;
		}

		pane.setViewportView((Component)component);
	}

	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub
		
	}
	
	public void show()
	{
		frame.pack();
		frame.show();
	}
	
	public void setTip(String text)
	{
	}

	public void hide() {
		frame.hide();
	}

	public void setTitle(String title) {
		frame.setTitle(title);
	}

	public void setBackground(Color color) {
		frame.setBackground(color);
	}

	public void setForeground(Color color) {
		frame.setForeground(color);
	}

	public Color getBackground() {
		return frame.getBackground();
	}

	public Color getForeground() {
		return frame.getForeground();
	}

	public String getName() {
		return frame.getName();
	}

	public void setName(String name) {
		frame.setName(name);
	}
	
	
}
