package org.one.stone.soup.xapp.swing.factories;

import java.awt.event.ActionListener;
import java.lang.reflect.Method;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.JMenu;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;

import org.one.stone.soup.entity.KeyValuePair;
import org.one.stone.soup.grfx.ColorHelper;
import org.one.stone.soup.stringhelper.StringArrayHelper;
import org.one.stone.soup.stringhelper.StringGenerator;
import org.one.stone.soup.xapp.XApplication;
import org.one.stone.soup.xapp.XappApplicationFrame;
import org.one.stone.soup.xapp.XappComponentStore;
import org.one.stone.soup.xapp.XappDB;
import org.one.stone.soup.xapp.XappReceiver;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.XappAnchor;
import org.one.stone.soup.xapp.components.XappButton;
import org.one.stone.soup.xapp.components.XappCheckbox;
import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.components.XappConsole;
import org.one.stone.soup.xapp.components.XappField;
import org.one.stone.soup.xapp.components.XappImage;
import org.one.stone.soup.xapp.components.XappImageButton;
import org.one.stone.soup.xapp.components.XappLabel;
import org.one.stone.soup.xapp.components.XappMenu;
import org.one.stone.soup.xapp.components.XappMenuItem;
import org.one.stone.soup.xapp.components.XappPasswordField;
import org.one.stone.soup.xapp.components.XappPopupMenu;
import org.one.stone.soup.xapp.components.XappProgressBar;
import org.one.stone.soup.xapp.components.XappSelectionField;
import org.one.stone.soup.xapp.components.XappSeparator;
import org.one.stone.soup.xapp.components.XappSlider;
import org.one.stone.soup.xapp.components.XappTextArea;
import org.one.stone.soup.xapp.components.XappTextField;
import org.one.stone.soup.xapp.components.compound.XappSplashPage;
import org.one.stone.soup.xapp.components.form.XForm;
import org.one.stone.soup.xapp.components.tree.XTree;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xapp.containers.XappDesktop;
import org.one.stone.soup.xapp.containers.XappFrame;
import org.one.stone.soup.xapp.containers.XappMenuBar;
import org.one.stone.soup.xapp.containers.XappPopup;
import org.one.stone.soup.xapp.containers.XappScrollPane;
import org.one.stone.soup.xapp.containers.XappSnapFrame;
import org.one.stone.soup.xapp.containers.XappSplitPane;
import org.one.stone.soup.xapp.containers.tabs.XappTabs;
import org.one.stone.soup.xapp.controller.xml.XmlSchemaViewController;
import org.one.stone.soup.xapp.factories.XappComponentFactory;
import org.one.stone.soup.xapp.factories.XappDragAndDropFacotry;
import org.one.stone.soup.xapp.filebrowser.XappFileBrowser;
import org.one.stone.soup.xapp.resource.manager.DefaultXuiResourceManager;
import org.one.stone.soup.xapp.resource.manager.XuiResourceManager;
import org.one.stone.soup.xapp.swing.components.XSwingForm;
import org.one.stone.soup.xapp.swing.components.XSwingTree;
import org.one.stone.soup.xapp.swing.components.XappSwingAnchor;
import org.one.stone.soup.xapp.swing.components.XappSwingApplicationFrame;
import org.one.stone.soup.xapp.swing.components.XappSwingBlank;
import org.one.stone.soup.xapp.swing.components.XappSwingButton;
import org.one.stone.soup.xapp.swing.components.XappSwingCheckbox;
import org.one.stone.soup.xapp.swing.components.XappSwingColorBrowser;
import org.one.stone.soup.xapp.swing.components.XappSwingConsole;
import org.one.stone.soup.xapp.swing.components.XappSwingDesktop;
import org.one.stone.soup.xapp.swing.components.XappSwingFileBrowser;
import org.one.stone.soup.xapp.swing.components.XappSwingFileEntryField;
import org.one.stone.soup.xapp.swing.components.XappSwingFrame;
import org.one.stone.soup.xapp.swing.components.XappSwingImage;
import org.one.stone.soup.xapp.swing.components.XappSwingImageButton;
import org.one.stone.soup.xapp.swing.components.XappSwingLabel;
import org.one.stone.soup.xapp.swing.components.XappSwingMenu;
import org.one.stone.soup.xapp.swing.components.XappSwingMenuBar;
import org.one.stone.soup.xapp.swing.components.XappSwingMenuItem;
import org.one.stone.soup.xapp.swing.components.XappSwingPasswordField;
import org.one.stone.soup.xapp.swing.components.XappSwingPopup;
import org.one.stone.soup.xapp.swing.components.XappSwingProgressBar;
import org.one.stone.soup.xapp.swing.components.XappSwingRadioSelectionField;
import org.one.stone.soup.xapp.swing.components.XappSwingScrollPane;
import org.one.stone.soup.xapp.swing.components.XappSwingSelectionField;
import org.one.stone.soup.xapp.swing.components.XappSwingSeparator;
import org.one.stone.soup.xapp.swing.components.XappSwingSlider;
import org.one.stone.soup.xapp.swing.components.XappSwingSnapFrame;
import org.one.stone.soup.xapp.swing.components.XappSwingSplashPage;
import org.one.stone.soup.xapp.swing.components.XappSwingSplitPane;
import org.one.stone.soup.xapp.swing.components.XappSwingSpreadsheet;
import org.one.stone.soup.xapp.swing.components.XappSwingTabs;
import org.one.stone.soup.xapp.swing.components.XappSwingTextArea;
import org.one.stone.soup.xapp.swing.components.XappSwingTextField;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlCloner;

public class XappSwingComponentFactory implements XappComponentFactory {

	private  XuiResourceManager resourceManager = new DefaultXuiResourceManager();
	private XappDragAndDropFacotry dragAndDropFactory = new XappSwingDragAndDropFactory();
	
public XappSwingComponentFactory() {
	super();
}

public XappFrame buildXappFrame(String title)
{
	XappFrame frame = new XappSwingFrame();
	frame.setTitle(title);
	return frame;
}

public void closeApplication(XApplication app)
{
	System.exit(0);
}

public  XappComponent buildAnchor(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String name = xData.getAttributeValueByName("name");
	String href = xData.getAttributeValueByName("href");
	String command = xData.getAttributeValueByName("command");

	XappAnchor anchor = new XappSwingAnchor(xData.getValue(),href);

	setBackground(anchor,xData);
	setColor(anchor,xData);
	setTip(anchor,xData);

	if(command!=null && command.length()>0)
	{
		anchor.setHref(false);
		anchor.setActionCommand(command);
		anchor.addActionListener(container);
	}

	if(name!=null)
	{
		anchor.setName(name);
		componentStore.addXappComponent(parentName+"."+name,anchor);
	}

	container.add(anchor);

	return anchor;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildXappComponent(org.one.stone.soup.xapp.XappContainer, java.lang.Object, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildXappComponent(XappContainer container,Object data,String parentName,XappComponentStore componentStore) {

	if(data instanceof String)
	{
		data = ((String)data).replaceAll("\\t","    ");
		data = StringArrayHelper.stringArrayToVector( StringArrayHelper.parseFields((String)data,'\n') );
	}
	if(data instanceof Vector)
	{
		Vector vect = (Vector)data;
		XappSwingLabel label = new XappSwingLabel();

		StringBuffer buffer = new StringBuffer();
		for(int loop=0;loop<vect.size();loop++)
		{
			data = vect.elementAt(loop);
			if(data instanceof String)
			{
				//JLabel label = new JLabel((String)data);
				//panel.add( label );
				buffer.append(data);
				buffer.append('\n');
			}
		}
		
		label.setText(buffer.toString());

		return (XappComponent)label;
	}
	else if(data instanceof XmlElement)
	{
		XmlElement xData = (XmlElement)data;
		if(xData.getName().equals("xappXappComponent"))
		{
			return buildXappComponent( container,xData );
		}
		else if(xData.getName().equals("separator"))
		{
			return buildSeparator( container,xData );
		}
		else if(xData.getName().equals("h"))
		{
			return buildHeading( container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("label"))
		{
			return buildLabel( container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("a") || xData.getName().equals("anchor"))
		{
			return buildAnchor( container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("input"))
		{
			return buildInput( container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("select"))
		{
			return buildSelect( container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("textarea"))
		{
			return buildTextArea( (XappComponent)componentStore.getXappComponent(parentName),container,xData,parentName,componentStore );
		}
		else if(xData.getName().equals("spreadsheet"))
		{
			XappSwingSpreadsheet spreadsheet = (XappSwingSpreadsheet)buildSpreadsheet( xData,componentStore );

			if(container instanceof XappReceiver)
			{
				spreadsheet.addReceiver( (XappReceiver)container );
			}
			
			container.add( spreadsheet );

			return spreadsheet;
		}
		else if(xData.getName().equals("table") || xData.getName().equals("form") || xData.getName().equals("XFormTable"))
		{
			// Not working yet
			if(xData.getAttributeValueByName("name")==null)
			{
				xData.addAttribute("name",parentName);
			}
			XSwingForm table = new XSwingForm( xData,componentStore );
			//table.doLayout();

			if(container instanceof XappReceiver)
			{
				table.addReceiver( (XappReceiver)container );
			}

			container.add( table );

			return table;
		}
		else if(xData.getName().equals("img"))
		{
			XappImage img = getImage("src",xData);
			String name = xData.getAttributeValueByName("name");
			if(name!=null)
			{
				img.setName(name);
				container.add(img);
			}

			return img;
		}
		else if(xData.getName().equals("container"))
		{
			XappComponentStore parts = new XappComponentStore();
			//XappComponent component = XappContainerFactory.buildContainer(xData.getElementByIndex(0),parts); not sure why inner element used
			XappComponent component = buildContainer(xData,parts);
			
			String name = xData.getAttributeValueByName("name");
			if(name!=null)
			{
				component.setName(name);
				componentStore.addXappComponent(name,component);
			}

			container.add(component);

			return component;
		}
		else
		{
			System.out.println("Unknown type: "+xData.getName());
		}
	}

	return null;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildHeading(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildHeading(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String value = xData.getValue();

	String size = xData.getAttributeValueByName("size");
	String face = xData.getAttributeValueByName("face");
	String style = xData.getAttributeValueByName("style");
	String color = xData.getAttributeValueByName("color");

	XappLabel label = new XappSwingLabel();
	label.setData( value );
	if(color!=null)
	{
		label.setForeground(ColorHelper.htmlToColor(color));
	}
	label.setFont(face,style,size);

	String name = xData.getAttributeValueByName("name");
	if(name!=null)
	{
		label.setName(name);
		container.add(label);
		componentStore.addXappComponent(parentName+"."+name,label);
	}

	return label;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildInput(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildInput(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String type = xData.getAttributeValueByName("type");

	if(type.equals("slider"))
	{
		return buildSlider( container,xData,parentName,componentStore );
	}
	else if(type.equals("progress"))
	{
		return buildProgress( container,xData,parentName,componentStore );
	}
	else if(type.equals("colorChooser") || type.equals("color"))
	{
		/*JColorChooser color = new JColorChooser();*/

		XappSwingColorBrowser color = new XappSwingColorBrowser();

		String name = xData.getAttributeValueByName("name");
		color.setName( name );
		setBackground(color,xData);
		setColor(color,xData);
		componentStore.addXappComponent( parentName+"."+name,color );

		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			color.setText( data );
		}
		else
		{
			color.setText("#000000");
		}

		container.add(color);

		//color.setBorder( new SoftBevelBorder(BevelBorder.RAISED) );

		return color;
	}
	else if( type.equals("text") )
	{
		int size = 10;
		String sizeV = xData.getAttributeValueByName("size");

		if(sizeV!=null)
		{
			size = Integer.parseInt(sizeV);
		}
		String name = xData.getAttributeValueByName("name");

		XappTextField text = null;
		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			data = StringGenerator.convertHtmlToString(data);
		}

		String format = xData.getAttributeValueByName("format");

		boolean formattingAvailable = false;

		Class clazz = null;
		try{
			clazz = Class.forName("org.one.stone.soup.xapp.componentStore.XappTextFormatter");
			Boolean result = (Boolean)clazz.getMethod("isAvailable",new Class[]{}).invoke(null,new Object[]{});

			formattingAvailable = result.booleanValue();
		}
		catch(Throwable e)
		{
			formattingAvailable = false;
		}

		if(format==null || formattingAvailable==false )
		{
			text = new XappSwingTextField();
			text.setSize(size);

			if(data!=null)
			{
				text.setData(data);
			}
		}
		else
		{
			try{
				Method method = clazz.getMethod("formatText",new Class[]{String.class,String.class,Integer.class});
				text = (XappSwingTextField)method.invoke(null,new Object[]{format,data,new Integer(size)});
			}
			catch(Exception e)
			{
				text = new XappSwingTextField();
				text.setSize(size);

				if(data!=null)
				{
					text.setData(data);
				}
			}
		}

		text.setName(name);
		componentStore.addXappComponent(parentName+"."+name,text);
		
		String enabled = xData.getAttributeValueByName("enabled");
		if(enabled!=null && enabled.equals("false"))
		{
			text.setEditable(false);
		}

		setBackground(text,xData);
		setColor(text,xData);
		setTip(text,xData);

		container.add(text);
		text.addActionListener( container );

		return text;
	}
	else if( type.equals("file") )
	{
		String name = xData.getAttributeValueByName("name");

		XappSwingFileEntryField file = new XappSwingFileEntryField();
		file.setName(name);
		componentStore.addXappComponent(parentName+"."+name,file);

		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			file.setText(data);
		}

		file.setSelectDirectory(false);

		setBackground(file,xData);
		setColor(file,xData);
		setTip(file,xData);

		container.add(file);

		return file;
	}
	else if( type.equals("directory") )
	{
		String name = xData.getAttributeValueByName("name");

		XappSwingFileEntryField file = new XappSwingFileEntryField();
		file.setName(name);
		componentStore.addXappComponent(parentName+"."+name,file);

		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			file.setText(data);
		}

		file.setSelectDirectory(true);

		setBackground(file,xData);
		setColor(file,xData);
		setTip(file,xData);

		container.add(file);

		return file;
	}
	else if( type.equals("password") )
	{
		int size = 10;
		String sizeV = xData.getAttributeValueByName("size");
		if(sizeV!=null)
		{
			size = Integer.parseInt(sizeV);
		}
		String name = xData.getAttributeValueByName("name");

		XappPasswordField text = new XappSwingPasswordField();
		text.setSize(size);
		text.setName(name);
		componentStore.addXappComponent(parentName+"."+name,text);
		
		setBackground(text,xData);
		setColor(text,xData);
		setTip(text,xData);

		container.add(text);
		text.addActionListener( container );

		return text;
	}
	else if( type.equals("checkbox") )
	{
		String name = xData.getAttributeValueByName("name");

		XappCheckbox check = new XappSwingCheckbox();
		check.setName(name);
		componentStore.addXappComponent(parentName+"."+name,check);
		
		String data = xData.getAttributeValueByName("value");
		if(data!=null)
		{
			if(data.equals("false"))
			{
				check.setData("false");
			}
			else
			{
				check.setData("true");
			}
		}
		//check.setIcon( new ImageIcon(ImageFactory.getWAIT()) );
		//check.setSelectedIcon( new ImageIcon(ImageFactory.getDOG()) );
		if(setBackground(check,xData)==false)
		{
			check.setBackground(container.getBackground());
		}
		if(setColor(check,xData)==false)
		{
			check.setForeground(container.getForeground());
		}
		setTip(check,xData);

		container.add(check);

		check.addActionListener( container );

		return check;
	}
	else if( type.equals("button") )
	{
		String name = xData.getAttributeValueByName("name");
		String value = xData.getAttributeValueByName("value");

		XappButton button = new XappSwingButton();
		button.setData(value);
		button.setName(name);
		componentStore.addXappComponent(parentName+"."+name,button);
		button.addActionListener( container );

		String width = xData.getAttributeValueByName("size");
		if(width!=null)
		{
			button.setSize( Integer.parseInt(width) );
		}

		setBackground(button,xData);
		setColor(button,xData);
		setTip(button,xData);

		container.add(button);

		return button;
	}
	else if( type.equals("imgButton") )
	{
		String name = xData.getAttributeValueByName("name");
		String value = xData.getAttributeValueByName("value");
		String enabled = xData.getAttributeValueByName("enabled");
		String border = xData.getAttributeValueByName("border");

		XappImageButton button = new XappSwingImageButton();
		button.setData(value);
		button.setName(name);
		componentStore.addXappComponent(parentName+"."+name,button);

		if(border!=null && border.equals("true"))
		{
			button.setHasBorder(true);
		}
		else
		{
			button.setHasBorder(false);
		}

		if(enabled!=null && enabled.equals("false"))
		{
			button.setEnabled(false);
		}

		if(xData.getAttributeValueByName("icon")!=null)
		{
			button.setIcon( getImage("icon",xData) );
		}
		if(xData.getAttributeValueByName("disabledIcon")!=null)
		{
			button.setDisabledIcon( getImage("disabledIcon",xData) );
		}
		if(xData.getAttributeValueByName("selectedIcon")!=null)
		{
			button.setSelectedIcon( getImage("selectedIcon",xData) );
		}

		setBackground(button,xData);
		setColor(button,xData);
		setTip(button,xData);

		button.addActionListener( container );

		container.add(button);

		return button;
	}
	else if( type.equals("radio") )
	{
		String group = xData.getAttributeValueByName("group");
		if(group==null)
		{
			group="undefined";
		}

		XappSwingRadioSelectionField selectionGroup = (XappSwingRadioSelectionField)componentStore.getField(parentName+"."+group);
		if(selectionGroup==null)
		{
			selectionGroup = new XappSwingRadioSelectionField(group);
			componentStore.addField(parentName+"."+group,selectionGroup);
		}
		
		String name = xData.getAttributeValueByName("name");

		XappSwingRadioSelectionField.XappSwingRadioButton button = (XappSwingRadioSelectionField.XappSwingRadioButton)selectionGroup.addOption(name);
		componentStore.addField(parentName+"."+name,button);
		
		if(setBackground(button,xData)==false)
		{
			button.setBackground(container.getBackground());
		}
		if(setColor(button,xData)==false)
		{
			button.setForeground(container.getForeground());
		}
		setTip(button,xData);
		
		((JRadioButton)button.getUI()).setActionCommand(group);
		((JRadioButton)button.getUI()).addActionListener(container);

		return button;
	}
	else if( type.equals("submit") )
	{
		String value = xData.getAttributeValueByName("value");

		XappButton button = new XappSwingButton();
		button.setData(value);
		button.setName("submit");
		componentStore.addXappComponent(parentName+".submit",button);
		
		button.addActionListener( container );
		setBackground(button,xData);
		setColor(button,xData);
		setTip(button,xData);

		return button;
	}

	return null;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildXappComponent(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement)
 */
public  XappComponent buildXappComponent(XappContainer container,XmlElement xData)
{
	try{
		Class clazz = Class.forName(xData.getAttributeValueByName("class"));
		XappComponent component = (XappComponent)clazz.getConstructor(new Class[]{XappContainer.class,XmlElement.class}).newInstance(new Object[]{container,xData});
		container.add(component);
		return component;
	}
	catch(Exception e)
	{
		XappRootApplication.displayException(e);
		return null;
	}
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildSeparator(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement)
 */
public  XappComponent buildSeparator(XappContainer container,XmlElement xData)
{
		XappSeparator sep = new XappSwingSeparator();
		sep.setWidth(100);

		String width = xData.getAttributeValueByName("width");
		if(width!=null)
		{
			sep.setWidth(Integer.parseInt(width));
		}

		String orientation = xData.getAttributeValueByName("orientation");
		if(orientation!=null)
		{
			sep.setOrientation(orientation);
		}

		setBackground(sep,xData);
		setColor(sep,xData);
		setTip(sep,xData);

		container.add(sep);

		return sep;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildLabel(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildLabel(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
		String data = xData.getValue();

		XappLabel label = new XappSwingLabel();
		label.setData(data);
		
		setBackground(label,xData);
		setColor(label,xData);
		setTip(label,xData);

		String name = xData.getAttributeValueByName("name");
		if(name!=null)
		{
			label.setName(name);
			componentStore.addXappComponent(parentName+"."+name,label);
			container.add(label);
		}

		return label;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildProgress(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildProgress(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String name = xData.getAttributeValueByName("name");
	
	XappProgressBar progress = new XappSwingProgressBar();
	progress.setMinimum(xData.getAttributeValueByName("min"));
	progress.setMaximum(xData.getAttributeValueByName("max"));
	progress.setOrientation( xData.getAttributeValueByName("orientation") );
	
	String size = xData.getAttributeValueByName("size");
	if( !(size==null || size.length()==0) )
	{
		progress.setSize( Integer.parseInt( size ) );
	}
	
	String title = xData.getAttributeValueByName("title");
	if(title!=null)
	{
		progress.setTitle(title);
	}
	
	componentStore.addXappComponent(parentName+"."+name,progress);
	
	progress.setData(xData.getAttributeValueByName("value"));

	setBackground(progress,xData);
	setColor(progress,xData);
	setTip(progress,xData);

	container.add(progress);

	return progress;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildSelect(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildSelect(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String name = xData.getAttributeValueByName("name");
	String value = xData.getAttributeValueByName("value");

	Vector optionData = new Vector();	
	
	String dataSource = xData.getAttributeValueByName("dataSource");
	if(dataSource!=null)
	{
		Hashtable optionsMap = XappDB.findList(dataSource);
		Vector list = KeyValuePair.createKeyValuePairVector(optionsMap);
		
		optionData.addAll(list);
	}

	KeyValuePair selectedItem = null;
	Vector options = xData.getElementsByName("option");

	for(int loop=0;loop<options.size();loop++)
	{
		String key = ((XmlElement)options.elementAt(loop)).getValue();
		String keyValue = ((XmlElement)options.elementAt(loop)).getAttributeValueByName("value");
		if(keyValue==null)
		{
			keyValue = key;
		}
		KeyValuePair option = new KeyValuePair(key,keyValue);

		if(value!=null && keyValue.equals(value))
		{
			selectedItem = option;
		}
		
		optionData.add( option );
	}
	optionData = KeyValuePair.sort(optionData,KeyValuePair.ASCENDING);
	
	XappSelectionField list = new XappSwingSelectionField();
	list.appendOptions((KeyValuePair[])optionData.toArray(new KeyValuePair[]{}));
	list.setName(name);
	componentStore.addXappComponent(parentName+"."+name,list);
	
	String editable = xData.getAttributeValueByName("editable");
	if(editable!=null && editable.equals("true"))
	{
		list.setEditable(true);
		if(value!=null)
		{
			list.setData(value);
		}
	}

	if(selectedItem!=null)
	{
		list.setData(selectedItem.value);
	}

	setBackground(list,xData);
	setColor(list,xData);
	setTip(list,xData);

	list.addActionListener( container );

	container.add(list);

	return list;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildSlider(org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildSlider(XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String name = xData.getAttributeValueByName("name");
	int min = 0;
	try{
		min = Integer.parseInt(xData.getAttributeValueByName("min"));
	}
	catch(Exception e){}

	int max = 100;
	try{
		max = Integer.parseInt(xData.getAttributeValueByName("max"));
	}
	catch(Exception e){}
	int value = 50;
	try
	{
		value = Integer.parseInt(xData.getAttributeValueByName("value"));
	}
	catch(Exception e){}
	if(value>max)
	{
		max = value;
	}

	XappSlider slider = new XappSwingSlider();
	slider.setMinimum( ""+min );
	slider.setMaximum( ""+max );
	slider.setName(name);
	componentStore.addXappComponent(parentName+"."+name,slider);
	
	slider.setOrientation(xData.getAttributeValueByName("orientation"));
	
	String editable = xData.getAttributeValueByName("editable");
	if(editable!=null && editable.equals("false"))
	{
		slider.setEditable(false);	
	}
	else
	{
		slider.setEditable(true);	
	}

	setBackground(slider,xData);
	setColor(slider,xData);
	setTip(slider,xData);

	container.add(slider);

	return slider;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildSpreadsheet(org.one.stone.soup.xml.XmlElement, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildSpreadsheet(XmlElement xData,XappComponentStore componentStore)
{
	XappSwingSpreadsheet spreadsheet = new XappSwingSpreadsheet(xData);

	String name = xData.getAttributeValueByName("name");
	
	spreadsheet.setName(name);
	componentStore.addXappComponent(name,spreadsheet);
	
	return spreadsheet;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildTextArea(java.awt.XappComponent, org.one.stone.soup.xapp.XappContainer, org.one.stone.soup.xml.XmlElement, java.lang.String, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildTextArea(XappComponent parent,XappContainer container,XmlElement xData,String parentName,XappComponentStore componentStore)
{
	String name = xData.getAttributeValueByName("name");
	String editable = xData.getAttributeValueByName("editable");
	int cols = Integer.parseInt(xData.getAttributeValueByName("cols"));
	int rows = Integer.parseInt(xData.getAttributeValueByName("rows"));

	XappTextArea text = new XappSwingTextArea();
	text.setRows(rows);
	text.setColumns(cols);
	text.setName(name);
	componentStore.addXappComponent(parentName+"."+name,text);
	
	setBackground(text,xData);
	setColor(text,xData);
	setTip(text,xData);

	if( editable!=null && editable.equals("false") )
	{
		text.setEditable(false);
	}

	StringBuffer buffer = new StringBuffer();
	for(int loop=0;loop<xData.getElementCount();loop++)
	{
		buffer.append(xData.getData(loop)+"\n");
	}
	text.setData(buffer.toString());

	container.add(text);

	text.setStyle( xData.getAttributeValueByName("style") );

	return text;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#getImageIcon(java.lang.String, org.one.stone.soup.xml.XmlElement)
 */
public  XappImage getImage(String attributeName,XmlElement xData)
{
	String src = xData.getAttributeValueByName(attributeName);

	XappImage image = null;
	if(src!=null)
	{
		image = getImage(src);
	}

	if(image==null)
	{
		return getImage("jar://resource/bad-file.png");
	}
	else
	{
		return image;
	}
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#getImage(java.lang.String)
 */
public XappImage getImage(String imageName)
{
	XappImage image = new XappSwingImage(resourceManager);
	image.setData(imageName);
	
	return image;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#setResourceManager(org.one.stone.soup.xapp.resource.manager.XuiResourceManager)
 */
public  void setResourceManager(XuiResourceManager manager)
{
	resourceManager = manager;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#setBackground(java.awt.XappComponent, org.one.stone.soup.xml.XmlElement)
 */
public  boolean setBackground(XappComponent component,XmlElement table)
{
	String bgColor = table.getAttributeValueByName("bgcolor");
	if(bgColor!=null)
	{
		component.setBackground( ColorHelper.htmlToColor(bgColor) );
		return true;
	}
	return false;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#setColor(java.awt.XappComponent, org.one.stone.soup.xml.XmlElement)
 */
public  boolean setColor(XappComponent component,XmlElement table)
{
	String color = table.getAttributeValueByName("color");
	if(color!=null)
	{
		component.setForeground( ColorHelper.htmlToColor(color) );
		return true;
	}
	return false;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#setTip(javax.swing.JXappComponent, org.one.stone.soup.xml.XmlElement)
 */
public  void setTip(XappComponent component,XmlElement xData)
{
	String tip = xData.getAttributeValueByName("tip");
	if(tip!=null)
	{
		component.setTip(tip);
	}
}

public XappMenuBar buildXappMenuBar(XmlElement xMenuBar,XappComponentStore store)
{
	return new XappSwingMenuBar(xMenuBar,store);
}

public XappPopup buildXappPopup(XmlElement xPopup)
{
	return new XappSwingPopup(xPopup);
}

public  void buildMenu(XmlElement xMenu,/*Hashtable menuMap,*/ActionListener listener,XappField owner,XappComponentStore componentStore)
{
	boolean isPopup = false;
	if(owner instanceof XappPopupMenu)
	{
		isPopup = true;
	}

	for(int loopO=0;loopO<xMenu.getElementCount();loopO++)
	{
		XmlElement xItem = xMenu.getElementByIndex(loopO);
		if(xItem.getName().equals("separator"))
		{
			if(isPopup)
			{
				((JPopupMenu)owner).addSeparator();
			}
			else
			{
				((JMenu)owner).addSeparator();
			}
		}
		else if(xItem.getName().equals("item"))
		{
			buildMenuItem(xItem,/*menuMap,*/listener,owner,isPopup,componentStore);
		}
		else if(xItem.getName().equals("menu"))
		{
			XappMenu menu = new XappSwingMenu();
			menu.setName(xItem.getAttributeValueByName("name"));

			/*String command = xItem.getAttributeValueByName("command");
			if(command!=null)
			{
				menu.setActionCommand(command);
			}
			else
			{
				menu.setActionCommand(xItem.getAttributeValueByName("name"));
			}*/
			//menuMap.put(xItem.getAttributeValueByName("name"),menu);
			componentStore.addXappComponent("menu."+xItem.getAttributeValueByName("name"),menu);

			String enabled = xItem.getAttributeValueByName("enabled");
			if(enabled!=null && enabled.equals("false"))
			{
				menu.setEnabled(false);
			}

			buildMenu(xItem,/*menuMap,*/listener,menu,componentStore);

			if(isPopup)
			{
				((XappPopupMenu)owner).add(menu);
			}
			else
			{
				((XappMenu)owner).add(menu);
			}
			menu.addActionListener(listener);
		}
	}
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildMenuItem(org.one.stone.soup.xml.XmlElement, java.awt.event.ActionListener, java.lang.Object, boolean, org.one.stone.soup.xapp.XappComponentStore)
 */
public  void buildMenuItem(XmlElement xItem/*,Hashtable menuMap*/,ActionListener listener,XappField owner,boolean isPopup,XappComponentStore componentStore)
{
	XappMenuItem item = new XappSwingMenuItem();
	item.setName(xItem.getAttributeValueByName("name"));

	String command = xItem.getAttributeValueByName("command");
	if(command==null)
	{
		command = item.getName();
	}
	item.setData(command);

	String icon = xItem.getAttributeValueByName("icon");
	if(icon!=null && icon.length()>0)
	{
		item.setIcon( getImage(icon) );
	}
	componentStore.addXappComponent("menuItem."+xItem.getAttributeValueByName("name"),item);
	//menuMap.put(xItem.getAttributeValueByName("name"),item);

	String enabled = xItem.getAttributeValueByName("enabled");
	if(enabled!=null && enabled.equals("false"))
	{
		item.setEditable(false);
	}

	if(isPopup)
	{
		((XappPopupMenu)owner).add(item);
	}
	else
	{
		((XappMenu)owner).add(item);
	}
	item.addActionListener(listener);
}

private  void buildApplications(XappDesktop desktop,Vector applications,XappComponentStore componentStore)
{
	for(int loop=0;loop<applications.size();loop++)
	{
		XmlElement application = (XmlElement)applications.elementAt(loop);

		desktop.addApplication(application);
	}
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildContainer(org.one.stone.soup.xml.XmlElement, org.one.stone.soup.xapp.XappComponentStore)
 */
public  XappComponent buildContainer(XmlElement xui,XappComponentStore componentStore)
{
	if(xui==null)
	{
		return null;
	}
	String type = xui.getAttributeValueByName("type");
	String name = xui.getAttributeValueByName("name");

	if(type==null)
	{
		if(xui.getName().equals("XFormTable") || xui.getName().equals("table"))
		{
			type = "table";
		}
		else if(xui.getName().equals("XTree"))
		{
			type = "tree";
		}
		else if(xui.getName().equals("spreadsheet"))
		{
			type = "spreadsheet";
		}
		else
		{
			return new XappSwingBlank();
		}
	}

	if(type.length()>7 && type.substring(0,7).equals("class:"))
	{
		try{
			XappComponent component = (XappComponent)Class.forName(type.substring(7)).newInstance();
			if(name!=null)
			{
				componentStore.addXappComponent(name,component);
			}
			
			return component;
		}
		catch(Exception e)
		{
			XappRootApplication.displayException(e);
			return null;
		}
	}
	else if(type.equals("spreadsheet"))
	{
		XappComponent spreadsheet = buildSpreadsheet(xui,componentStore);
		
		if(name!=null)
		{
			componentStore.addXappComponent(name,spreadsheet);
		}
		
		return spreadsheet;
	}
	else if(type.equals("tabbedPane"))
	{
		Vector tabs = xui.getElementsByName("tab");
		XappTabs tabPane = new XappSwingTabs();

		tabPane.setOrientation(xui.getAttributeValueByName("orientation"));
		tabPane.setLayout(xui.getAttributeValueByName("layout"));

		for(int loop=0;loop<tabs.size();loop++)
		{
			XmlElement tab = (XmlElement)tabs.elementAt(loop);
			tabPane.add(tab.getAttributeValueByName("title"),buildContainer(tab.getElementByIndex(0),componentStore));
		}

		if(name!=null)
		{
			componentStore.addXappComponent(name,tabPane);
		}
		return tabPane;
	}
	else if(type.equals("splitPane"))
	{
		String split = xui.getAttributeValueByName("split");
		if(split==null)
		{
			split="vertical";
		}
		
		XappSplitPane splitPane = new XappSwingSplitPane();
		splitPane.setOrientation(split);

		XmlElement top = xui.getElementByName("top");
		if(top!=null)
		{
			splitPane.setTop( buildContainer(top.getElementByIndex(0),componentStore) );
		}

		XmlElement bottom = xui.getElementByName("bottom");
		if(bottom!=null)
		{
			splitPane.setBottom( buildContainer(bottom.getElementByIndex(0),componentStore) );
		}
		
		if(name!=null)
		{
			componentStore.addXappComponent(name,splitPane);
		}

		return splitPane;
	}
	else if(type.equals("snapFrame"))
	{
		XappSnapFrame snapFrame = new XappSwingSnapFrame();

		snapFrame.add( buildContainer(xui.getElementByIndex(0),componentStore) );
		
		if(name!=null)
		{
			componentStore.addXappComponent(name,snapFrame);
		}

		return snapFrame;
	}
	else if(type.equals("scrollPane"))
	{
		String bars = xui.getAttributeValueByName("scrollBars");

		XappScrollPane scrollPane = new XappSwingScrollPane();

		scrollPane.setBars(bars);

		XmlElement contents = xui.getElementByIndex(0);
		if(contents!=null)
		{
			scrollPane.add( buildContainer(contents,componentStore) );
		}

		if(name!=null)
		{
			componentStore.addXappComponent(name,scrollPane);
		}

		return scrollPane;
	}
	else if(type.equals("desktop"))
	{
		XappDesktop desktop = new XappSwingDesktop();

		/*XmlElement contents = xui.getElementByName("contents");
		if(contents!=null)
		{
			desktop.add( buildContainer(contents,componentStore) );
		}*/

		if(name!=null)
		{
			componentStore.addXappComponent( name,desktop );
		}

		Vector applications = xui.getElementsByName("application");

		buildApplications(desktop,applications,componentStore);

		//desktop.doLayout();
		//desktop.setSize(400,400);
		return desktop;
	}
	else if(type.equals("table"))
	{
		XmlElement xTable = XmlCloner.getClone( xui );
		XSwingForm table = new XSwingForm( xTable,componentStore );
		table.doLayout();
		if(table.getName()!=null)
		{
			componentStore.addXappComponent( table.getName(),table );
		}

		return table;
	}
	return null;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.factories.XappComponentFactoryInterface#buildContainers(org.one.stone.soup.xml.XmlElement, org.one.stone.soup.xapp.XappComponentStore)
 */
public  void buildContainers(XmlElement xui,XappComponentStore componentStore)
{
	componentStore.addXappComponent( "root",buildContainer(xui,componentStore) );
}

public XappApplicationFrame buildApplicationFrame() {
	return new XappSwingApplicationFrame();
}

public XappDragAndDropFacotry getDragAndDropFactory() {
	return dragAndDropFactory;
}

public XForm buildForm(XmlElement xActionsForm) {
	return buildForm(xActionsForm,new XappComponentStore());
}

public XForm buildForm(XmlElement xActionsForm,XappComponentStore store) {
	return new XSwingForm(xActionsForm,store);
}

public XappFrame buildFrame() {
	return new XappSwingFrame();
}

public XappSnapFrame buildSnapFrame() {
	return new XappSwingSnapFrame();
}

public XappFileBrowser buildFileBrowser(String title,String fileTypeName,String fileExtension)
{
	return new XappSwingFileBrowser(title,fileTypeName,fileExtension);
}

public XappConsole buildConsole()
{
	return new XappSwingConsole();
}

public XappSplashPage buildSplashPage(XmlElement table)
{
	return new XappSwingSplashPage(table);
}

public XTree buildXTree(XmlElement modelRoot,XmlSchemaViewController viewController)
{
	return new XSwingTree(modelRoot,viewController);
}
}