package org.one.stone.soup.xml;

/*
 * Wet-Wired.com Xml Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
	* The TagTokens class is a lightweight container for the characters used to
	* delimit XML elements.
*/

public class TagTokens {
	public char startTagChar = '<';
	public char endTagChar = '>';
	public char marker = '/';

	public String startTag = "<";
	public String endTag = "</";

	public String closeTag = ">";
	public String closeEmptyTag = "/>";

	public static final TagTokens STANDARD_TAGS = new TagTokens();
/**
 * TagTokens constructor comment.
 */
public TagTokens() {
	super();
}
/**
 *
 * @return java.lang.String
 */
public String getCloseEmptyTag() {
	return closeEmptyTag;
}
/**
 *
 * @return java.lang.String
 */
public String getCloseTag() {
	return closeTag;
}
/**
 *
 * @return java.lang.String
 */
public String getEndTag() {
	return endTag;
}
/**
 *
 * @return char
 */
public char getEndTagChar() {
	return endTagChar;
}
/**
 *
 * @return char
 */
public char getMarker() {
	return marker;
}
/**
 *
 * @return java.lang.String
 */
public String getStartTag() {
	return startTag;
}
/**
 *
 * @return char
 */
public char getStartTagChar() {
	return startTagChar;
}
private void rebuild() {
	startTag = ""+startTagChar;
	endTag = ""+startTagChar+marker;

	closeTag = ""+endTagChar;
	closeEmptyTag = ""+marker+endTagChar;
}
/**
 *
 * @param newEndTagChar char
 */
public void setEndTagChar(char newEndTagChar) {
	endTagChar = newEndTagChar;
	rebuild();
}
/**
 *
 * @param newMarker char
 */
public void setMarker(char newMarker) {
	marker = newMarker;
	rebuild();
}
/**
 *
 * @param newStartTagChar char
 */
public void setStartTagChar(char newStartTagChar) {
	startTagChar = newStartTagChar;
	rebuild();
}
}
