package org.one.stone.soup.xml.wrapper;

import org.one.stone.soup.stringhelper.StringArrayHelper;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlProcessor;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlElementWrapperProcessor implements XmlProcessor {
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xml.XmlProcessor#process(org.one.stone.soup.xml.XmlElement, org.one.stone.soup.xml.XmlElement, int, java.lang.String)
	 */
	public boolean process(XmlElement root,XmlElement directive, XmlElement target, int lineNo,
			String fileName) throws XmlParseException {
		if(directive.getName().equals("elementWrapper"))
		{
			String[] path = StringArrayHelper.parseFields(directive.getAttributeValueByName("path"),'/');
			int[] indexPath = new int[path.length];
			for(int loop=0;loop<path.length;loop++)
			{
				indexPath[loop]=Integer.parseInt(path[loop]);
			}
			
			XmlElementWrapper wrapper = new XmlElementWrapper(directive.getAttributeValueByName("name"),root,indexPath);

			wrapper.setCreated(true);
			for(int loop=0;loop<directive.getAttributeCount();loop++)
			{
				String name = directive.getAttributeNameByIndex(loop);
				if(name.charAt(0)!='_')
				{
					continue;
				}

				String value = directive.getAttributeValueByIndex(loop);
				if(name.equals("name") || name.equals("path"))
				{
					continue;
				}
				wrapper.addAttribute( name,value );
			}
			wrapper.setCreated(false);

			target.addChild( wrapper );
			return true;
		}
		return false;
	}
}
